<?php

if( !defined('IN_ROSTER') )
{
    exit('Detected invalid access to this file!');
}

require_once (ROSTER_LIB . 'skill.php');
require_once (ROSTER_LIB . 'recipes.php');

$charid = $roster->data['member_id'];

$skills = skill_get_many($charid);

$skill_list = array();
$i=0;
$skill_name = '';
$returnstring = '';
$returnstring .= "<a name=\"top\">&nbsp;</a>\n";
$returnstring .= '<div align="center">';
$skill_name_divider = '';
foreach ($skills as $skillgroup) {
	foreach ($skillgroup as $skill) {
		$st = $skill->data['skill_type'];
		if ($skill->data['skill_type']=='Métiers' || $skill->data['skill_type']=='Compétences secondaires') {
			if ($skill->data['skill_name']!='Monte' && $skill->data['skill_name']!='Pêche' && $skill->data['skill_name']!='Dépeçge' && $skill->data['skill_name']!='Minage' && $skill->data['skill_name']!='Herboristerie') {
				$skill_list[$i] = $skill->data['skill_name'];
				$skill_level[$i] = $skill->data['skill_level'];
				$i++;
				$skill_name_header = $skill->data['skill_name'];
				$returnstring .= $skill_name_divider .'<a href="' . makelink('#' . strtolower(str_replace(' ','',$skill_name_header))) . '">' . $skill_name_header . '</a>';
				$skill_name_divider = '&nbsp;-&nbsp;';
			}
		}
	}
}
$returnstring .= "</div>\n<br />\n";

$allrecipes=array();
$i=0;
foreach($skill_list as $skill)
{
	switch($skill)
	{
		case 'Alchimie':
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=171&source=test&locale=frFR',30);
			$i++;
			break;
		case 'Forge':
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=164&source=test&locale=frFR',30);
			$i++;
			break;
		case 'Cuisine':
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=185&source=test&locale=frFR',30);
			$i++;
			break;
		case 'Enchantement':
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=333&source=test&locale=frFR',30);
			$i++;
			break;
		case 'Ingénierie':
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=202&source=test&locale=frFR',30);
			$i++;
			break;
		case 'Premiers soins':
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=129&source=test&locale=frFR',30);
			$i++;
			break;
		case 'Travail du cuir':
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=165&source=test&locale=frFR',30);
			$i++;
			break;
		case 'Couture':
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=197&source=test&locale=frFR',30);
			$i++;
			break;
		case 'Joaillerie':
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=755&source=test&locale=frFR',30);
			$i++;
			break;
		default:
			$allrecipes[$i] ='';
			$i++;
			break;
	}
}
foreach($allrecipes as $index => $allrecipesperskill)
{
	preg_match_all('/(?<=\<tr class=\"[dl]r\"\>)((.(?!\<\/tr))*)/si',$allrecipesperskill,$matches);
	foreach ($matches[0] as $nr => $recipe)
	{
		preg_match_all('/(\<td[\w \\\'\"=]*\>)(.*)(?=\<\/td)/mi',$recipe,$lines)."\n";
		$parsedrecipes[$index][$nr]['icon'] = strtolower($lines[2][0]);
		$parsedrecipes[$index][$nr]['icon'] = str_replace("src=\"/images/icons", "src=\"".ROSTER_URL.$roster->config['interface_url']."Interface/Icons", $parsedrecipes[$index][$nr]['icon']);
		$parsedrecipes[$index][$nr]['icon'] = str_replace(".png", ".".$roster->config['img_suffix']."\" alt=\"" , $parsedrecipes[$index][$nr]['icon']);
		preg_match('/(\<a[^\>]* href=\"([^\"]*)\"\>)([^<]*)/i',$lines[2][1],$name);
		$parsedrecipes[$index][$nr]['name'] = $name[3];
		preg_match('/href=\"([^\"]*)\"/i',$lines[2][5],$link);
		//$recipes[$index][$nr]['components'] = $lines[2][4];
		if(array_key_exists('1',$link)) {
			$parsedrecipes[$index][$nr]['i_link'] = $link[1];
		}
		//$recipes[$index][$nr]['category'] = $lines[2][2];
		$parsedrecipes[$index][$nr]['skill'] = $lines[2][3];
		preg_match('/(\<a[^\>]* href=\"([^\"]*)\"\>)([^<]*)(.*(\<a[^\>]* href=\"([^\"]*)\"\>\<span[^\>]*\>)([^<]*))?/i',$lines[2][1],$name);
		$parsedrecipes[$index][$nr]['r_link'] = $name[2];
		if (isset($name[6]))
		{
			$parsedrecipes[$index][$nr]['pat_link'] = $name[6];
			$parsedrecipes[$index][$nr]['pat_name'] = $name[7];
		} 
	}
}

//aprint($parsedrecipes);

$known = recipe_get_many( $charid,'', 'level' );
//aprint($known);

foreach($skill_list as $sindex => $skill) {
	foreach($parsedrecipes[$sindex] as $nr => $recipe) {
//		aprint($recipe);
		$allrecipenames[$sindex][]=$recipe['name'];
	}
	foreach($known as $kindex => $krecipe) {
		$knownrecipenames[$sindex][]=$krecipe->data['recipe_name'];
	}
	$diffrecipenames[$sindex] = array_diff($allrecipenames[$sindex],$knownrecipenames[$sindex]);
}

//aprint($allrecipenames);
//aprint($knownrecipenames);

//aprint($skill_level);
//aprint($diffrecipenames);

$first_run = 1;

foreach($skill_list as $sindex => $skill_name) {
	list($charskill_level, $maxskill_level) = explode(":", $skill_level[$sindex], 2);
	// make skill header
	if ( !$first_run )
		$returnstring .= '</table>' . border('sgray','end') . "<br />\n";
	$first_run = 0;
	// Set an link to the top behind the profession image
	$skill_image = 'Interface/Icons/' . $roster->locale->wordings[$roster->data['clientLocale']]['ts_iconArray'][$skill_name];
	$skill_image = "<img style=\"float:left;\" width=\"17\" height=\"17\" src=\"" . $roster->config['interface_url'] . $skill_image . '.' . $roster->config['img_suffix'] . "\" alt=\"\" />\n";

	$header = '<div style="cursor:pointer;width:600px;" onclick="showHide(\'table_' . $sindex . '\',\'img_' . $sindex . '\',\'' . $roster->config['img_url'] . 'minus.gif\',\'' . $roster->config['img_url'] . 'plus.gif\');">' . $skill_image . '<div style="display:inline;float:right;"><img id="img_' . $sindex . '" src="' . $roster->config['img_url'] . 'plus.gif" alt="" /></div><a name="' . strtolower(str_replace(' ','',$skill_name)) . '"></a>' . $skill_name . '&nbsp;' . $charskill_level . ':' . $maxskill_level .'</div>';

	$returnstring .= border('sgray','start',$header) . "\n<table width=\"100%\" style=\"display:none;\";\" class=\"bodyline\" cellspacing=\"0\" id=\"table_$sindex\">\n";

	$returnstring .= '<tr><th class="membersHeader">' . $roster->locale->act['item'] . '</th>  <th class="membersHeader">' . $roster->locale->act['name'] . '</th> <th class="membersHeader">' . $roster->locale->act['skill_level'] . '</th></tr>';

	$stripe = 0;
	foreach($diffrecipenames[$sindex] as $dindex => $diffrecipename) {

		// make recipe row
		if ($charskill_level >= $parsedrecipes[$sindex][$dindex]['skill']){
			$skill_color = "00FF00";
		} else {
			$skill_color = "FF0000";
		}
		$stripe = (($stripe%2)+1);
		$returnstring .= '  <tr><td class="membersRow' . $stripe . ' equip">' . $parsedrecipes[$sindex][$dindex]['icon'] . '</td>';
		if(array_key_exists('i_link', $parsedrecipes[$sindex][$dindex]))
		{
			$link = "http://wow.allakhazam.com".$parsedrecipes[$sindex][$dindex]['i_link'];
			$returnstring .= '</td><td class="membersRow' . $stripe . '"><span><a href="' . $link . '">&nbsp;' . $parsedrecipes[$sindex][$dindex]['name'] . '</a></span>';
		} else {
			$returnstring .= '</td><td class="membersRow' . $stripe . '"><span style="color:#CBA300">&nbsp;' . $parsedrecipes[$sindex][$dindex]['name'] . '</span>';
		}
		if(array_key_exists('pat_link', $parsedrecipes[$sindex][$dindex]))
		{
			$plink = "http://wow.allakhazam.com".$parsedrecipes[$sindex][$dindex]['pat_link'];
			$pname = $parsedrecipes[$sindex][$dindex]['pat_name'];
			$returnstring .= "<br /><a href=\"$plink\">&nbsp;$pname</a>";
		}
		$returnstring .= '</td>';
		$returnstring .= '<td class="membersRow' . $stripe . '"><span style="color:#'.$skill_color.'" >&nbsp;' . $parsedrecipes[$sindex][$dindex]['skill'] . '</span></td>';

		$returnstring .= '  </tr>';
	}

	// make skill footer
	$returnstring .= "</table>" . border('sgray','end');

}

echo $returnstring;
